require "import"
import "com.androlua.LuaDialog"
import "android.content.Context"
import "android.os.Vibrator"
import "android.content.Intent"
import "android.net.Uri"
import "android.widget.*"
import "android.view.*"

local dialogTitle = "عالم المكفوفين التقني"
local dialogDescription = [[
قناة "عالم المكفوفين" تَهْتَمُ بِتَقْدِيمِ مُحْتَوَى تَقْنِيٍ مُتَمَيِزٍ يَخُصُ الأَشْخَاصَ المَكْفُوفِينَ وَذَوِي الإِعَاقَاتِ البَصَرِيَةِ.
نَسْعَى مِنْ خِلَالِ مَقَاطِعِ الفِيدِيُو وَالْمَقَالَاتِ إِلَى تَقْدِيمِ مُحْتَوَى مُتَنَوِعٍ يَشْمَلُ التَقَنِيَاتِ الحَدِيثَةَ الَتِي تُسهِلُ حَيَاتَهُمْ اليَوْمِيَةَ وَتُعَزِزُ اسْتِقْلَالِيَتَهُمْ.
اِكْتَشِفْ مَعَنَا آخِرَ الِابْتِكَارَاتِ وَالتَتْبِيقَاتِ الَتِي تُسَاعِدُ فِي تَحْسِينِ جَوْدَةِ حَيَاةِ الأَفْرَادِ المَكْفُوفِينَ،
وَاسْتَمْتِعْ بِمُحْتَوَى يُعَزِزُ التَوَعِيَةَ وَالتَفَاهُمَ حَوْلَ قَضَايَاهُمْ وَتَحَدِيَاتِهِمْ.
تَابِعْنَا لِتَكُونَ عَلَى إطْلَاعٍ دَائِمٍ بِكُلِ جَدِيدٍ فِي عَالَمِ التَكْنُولُوجِيَا المُخَصَصَةِ لِلْمَكْفُوفِينَ.
تَارِيخُ الإِنْضِمَامِ: 8 نَيْسَانَ، أَبْرِيلَ، 2023 مِيلَادِيٍ، الْمُوَافِقُ، 17 رَمَضَانَ، 1444 هِجْرِيٍ.
]]

local links = {
  "تابعونا على يوتيوب",
  "تلجرام",
  "واتساب"
}

local urls = {
  "https://youtube.com/@thetechnicalworldoftheblind?si=hwrBxoTaSoQAiXG0",
  "https://t.me/ealamalmakfufin",
  "https://whatsapp.com/channel/0029VaD0VskGE56ssr8MXg30"
}

local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
vibrator.vibrate(100)

layout = {
  LinearLayout,
  orientation = LinearLayout.VERTICAL,
  {
    TextView,
    text = dialogTitle,
    textSize = "22sp",
    gravity = 17,
    padding = "16dp",
  },
  {
    Button,
    text = "Close",
    onClick = function(view)
      dlg.dismiss()
      vibrator.vibrate(100)
    end,
    layout_width = "wrap_content",
    gravity = 17,
  },
  {
    TextView,
    text = dialogDescription,
    textSize = "18sp",
    gravity = 17,
    padding = "12dp",
  },
  {
    GridView,
    id = "grid",
    numColumns = 1,
    layout_width = "fill",
    layout_height = "fill",
  },
}

dlg = LuaDialog(service)
dlg.View = loadlayout(layout)
grid.adapter = SingleLineAdapter(service, String(links))

grid.onItemClick = function(l, v)
  task(100, function()
    dlg.dismiss()
    vibrator.vibrate(100)
    if service.playSoundTick then
      service.playSoundTick()
    end
    if v.text == links[1] then
      openLink(urls[1])
    elseif v.text == links[2] then
      openLink(urls[2])
    elseif v.text == links[3] then
      openLink(urls[3])
    end
  end)
end

function openLink(url)
  local intent = Intent(Intent.ACTION_VIEW)
  intent.setData(Uri.parse(url))
  context.startActivity(intent)
  if service.asyncSpeak then
    service.asyncSpeak("Link has been opened.")
  end
end

dlg.show()

function onKeyDown(code, event)
  if code == KeyEvent.KEYCODE_BACK then
    dlg.dismiss()
    return true
  end
end

return true